﻿namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private async static Task Main()
    {
        string[] sourceArray = new string[]
        {
            "London",
            "New York",
            "Paris",
            "Seoul",
            "Tokyo"
        };

        List<Task> taskList = new List<Task>();

        foreach(string source in sourceArray)
        {
            taskList.Add
            (
                Task.Run
                (
                    async () =>
                    {
                        await Task.Delay(1000);

                        Console.WriteLine($"[{DateTime.Now:HH:mm:ss}] {source}");
                    }
                )
            );
        }

        await Task.WhenAll(taskList);
    }

    #endregion
}